import java.math.*;
import java.util.*;

class Subsequence{

	public static void main(String[]args) throws Exception{
		java.io.BufferedReader fraTastaturet = new java.io.BufferedReader(new java.io.InputStreamReader(System.in));

		System.out.print("Hvor mange tall bestaar sekvensen av? ");
		System.out.flush();
		String ant = fraTastaturet.readLine();
		int size = Integer.parseInt(ant);

		boolean utskrift = true;
		if (size>=500){
			System.out.print("OI! Det var mange tall, vil du skrive dem ut til skjermen? (ja/nei) ");
			System.out.flush();
			String yeln = fraTastaturet.readLine();
			if (yeln.equals("ja")){
				utskrift = true;
			}else utskrift = false;
		}

		int nummer;
		do{
			System.out.print("Hvilken algoritme vil du bruke? (1-4) ");
			System.out.flush();
			String num = fraTastaturet.readLine();
			nummer = Integer.parseInt(num);
		}while(nummer<=0 || nummer>=5);

		int[] a = new int[size];

		if (utskrift) System.out.print("Sekvensen bestaar naa av: ");
		Random r = new java.util.Random();
		for(int i=0; i<size; i++){
			int tall = (int)(r.nextDouble()*15-5);
			a[i] = tall;
			if (utskrift) System.out.print(+tall +" ");
		}

		long start = System.currentTimeMillis();

		int sum;
		if (nummer==1){
			sum = maxSubSum1(a);
		}else if (nummer==2){
			sum = maxSubSum2(a);
		}else if (nummer==3){
			sum = maxSubSum3(a);
		}else{
			sum = maxSubSum4(a);
		}

		long stop = System.currentTimeMillis();
		long tid = stop-start;

		System.out.println("\n");
		System.out.println("Algoritmen brukte " +tid +" millisekunder!");
		System.out.println("Brukte algoritme " +nummer +" paa " +size +" tilfeldig genererte tall fra -4 til 9");
		System.out.println("Stoerste subsekvens-sum ble da: " +sum);
	}

//
// Cubic maximum contiguous subsequence sum algorithm.
//
	public static int maxSubSum1(int[]a){

		int maxSum = 0;

		for(int i = 0; i < a.length; i++){

			for(int j = i; j < a.length; j++){
				int thisSum = 0;

				for(int k = i; k <= j; k++){
					thisSum += a[k];
				}
				if(thisSum > maxSum)
					maxSum = thisSum;
			}
		}
		return maxSum;
	}

//
// Quadratic maximum contiguous subsequence sum algorithm.
//
	public static int maxSubSum2(int[]a){
		int maxSum = 0;

		for(int i = 0; i < a.length; i++){
			int thisSum = 0;

			for(int j = i; j < a.length; j++){
			thisSum += a[j];

			if(thisSum > maxSum)
				maxSum = thisSum;
			}
		}

		return maxSum;
	}

//
// Recursive maximum contiguous subsequence sum algorithm.
// Finds maximum sum in subarray spanning a[left..right].
// Does not attempt to maintain actual best sequence.
//
	private static int maxSumRec(int[]a, int left, int right){
		if(left == right)  // Base case
		if(a[left] > 0)
		return a[left];
		else return 0;

		int center = (left + right) / 2;
		int maxLeftSum  = maxSumRec(a, left, center);
		int maxRightSum = maxSumRec(a, center + 1, right);

		int maxLeftBorderSum = 0, leftBorderSum = 0;
		for(int i = center; i >= left; i--){
			leftBorderSum += a[i];
			if(leftBorderSum > maxLeftBorderSum)
			maxLeftBorderSum = leftBorderSum;
		}

		int maxRightBorderSum = 0, rightBorderSum = 0;
		for(int i = center + 1; i <= right; i++){
			rightBorderSum += a[i];
			if(rightBorderSum > maxRightBorderSum)
			maxRightBorderSum = rightBorderSum;
		}

		return max3(maxLeftSum, maxRightSum, maxLeftBorderSum + maxRightBorderSum);
	}


// Driver for divide-and-conquer maximum contiguous subsequence sum algorithm.

	public static int maxSubSum3(int[]a){
		return maxSumRec(a, 0, a.length - 1);
	}

// Return maximum of three integers.

	private static int max3(int a, int b, int c){
		return a > b ? a > c ? a : c : b > c ? b : c;
	}

//
// Linear-time maximum contiguous subsequence sum algorithm.
//
	public static int maxSubSum4(int[]a){
		int maxSum = 0, thisSum = 0;

		for(int j = 0; j < a.length; j++){
			thisSum += a[j];

			if(thisSum > maxSum) maxSum = thisSum;
			else if(thisSum < 0) thisSum = 0;
		}
		return maxSum;
	}
}